/*
*  Copyright 2019-2020 Zheng Jie
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*  http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*/
package cn.ysk.cashier.controller.shop;

import cn.ysk.cashier.annotation.Log;
import cn.ysk.cashier.dto.shop.TbMerchantCouponDto;
import cn.ysk.cashier.pojo.shop.TbMerchantCoupon;
import cn.ysk.cashier.pojo.shop.TbPurchaseNotice;
import cn.ysk.cashier.repository.shop.TbPurchaseNoticeRepository;
import cn.ysk.cashier.service.shop.TbMerchantCouponService;
import cn.ysk.cashier.dto.shop.TbMerchantCouponQueryCriteria;
import cn.ysk.cashier.service.shop.TbPurchaseNoticeService;
import org.springframework.data.domain.Pageable;
import lombok.RequiredArgsConstructor;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import io.swagger.annotations.*;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import javax.servlet.http.HttpServletResponse;

/**
* @website https://eladmin.vip
* @author lyf
* @date 2024-03-20
**/
@RestController
@RequiredArgsConstructor
@Api(tags = "/shop/coupon管理")
@RequestMapping("/api/tbMerchantCoupon")
public class TbMerchantCouponController {

    private final TbMerchantCouponService tbMerchantCouponService;
    private final TbPurchaseNoticeRepository noticeRepository;

    @ApiOperation("导出数据")
    public void exportTbMerchantCoupon(HttpServletResponse response, TbMerchantCouponQueryCriteria criteria) throws IOException {
        tbMerchantCouponService.download(tbMerchantCouponService.queryAll(criteria), response);
    }

    @GetMapping
    public ResponseEntity<Object> queryTbMerchantCoupon(TbMerchantCouponQueryCriteria criteria, Pageable pageable){
        return new ResponseEntity<>(tbMerchantCouponService.queryAll(criteria,pageable),HttpStatus.OK);
    }

    @GetMapping("/{id}")
    @ApiOperation("查询优惠卷")
    public ResponseEntity<Object> queryTbMerchantCouponById(@PathVariable("id")Integer id){
        Map result=new HashMap<>();
        TbMerchantCouponDto coupon = tbMerchantCouponService.findById(id);
        result.put("coupon",coupon);
        TbPurchaseNotice notice = noticeRepository.findByCouponId(id);
        result.put("notice",notice);
        return new ResponseEntity<>(result,HttpStatus.OK);
    }

    @PostMapping
    @Log("新增商家优惠卷:#resources.title")
    public ResponseEntity<Object> createTbMerchantCoupon(@Validated @RequestBody TbMerchantCoupon resources){
        return new ResponseEntity<>(tbMerchantCouponService.create(resources),HttpStatus.CREATED);
    }

    @PutMapping
    @Log("修改商家优惠卷:#resources.title")
    public ResponseEntity<Object> updateTbMerchantCoupon(@Validated @RequestBody TbMerchantCoupon resources){
        tbMerchantCouponService.update(resources);
        return new ResponseEntity<>(HttpStatus.NO_CONTENT);
    }

    @DeleteMapping
    @Log("删除商家优惠卷:#ids")
    public ResponseEntity<Object> deleteTbMerchantCoupon(@RequestBody Integer[] ids) {
        tbMerchantCouponService.deleteAll(ids);
        return new ResponseEntity<>(HttpStatus.OK);
    }
}